// PPgIonixUpdate.cpp : implementation file
#include "stdafx.h"
#include "emule.h"
#include "emuleDlg.h"
#include "OtherFunctions.h"
#include "serverWnd.h"
#include "IPFilter.h"
#include "Fakecheck.h" // [TPT] - Fakecheck
#include "IP2Country.h"
#include "PPgIonixUpdate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

// CPPgIonixUpdate dialog

IMPLEMENT_DYNAMIC(CPPgIonixUpdate, CPropertyPage)
CPPgIonixUpdate::CPPgIonixUpdate()
	: CPropertyPage(CPPgIonixUpdate::IDD)
{
}

void CPPgIonixUpdate::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgIonixUpdate, CPropertyPage)
	//MORPH START Ipfilter.dat update
	ON_BN_CLICKED(IDC_AUTOUPIPFILTER , OnSettingsChange)
	ON_BN_CLICKED(IDC_UPDATEIPFURL, OnBnClickedUpdateipfurl)
	ON_BN_CLICKED(IDC_RESETIPFURL, OnBnClickedResetipfurl)
	ON_EN_CHANGE(IDC_UPDATE_URL_IPFILTER, OnSettingsChange)
	//MORPH END Ipfilter.dat update
	// [TPT] - Fakecheck
	ON_BN_CLICKED(IDC_PPG_FAKESTARTUP, OnSettingsChange)
	ON_BN_CLICKED(IDC_PPG_FAKEUP, OnBnClickedUpdatefakes)
	ON_BN_CLICKED(IDC_RESETFAKESURL, OnBnClickedResetfakes)
	ON_EN_CHANGE(IDC_PPG_FAKEURL, OnSettingsChange)
	// [TPT] - Fakecheck end
	// IP2Country Auto-updating - Start
	ON_EN_CHANGE(IDC_UPDATE_URL_IP2COUNTRY, OnSettingsChange)
    ON_EN_CHANGE(IDC_UPDATE_VER_URL_IP2COUNTRY, OnSettingsChange)
	ON_BN_CLICKED(IDC_UPDATEIPCURL, OnBnClickedUpdateipcurl)
	ON_BN_CLICKED(IDC_RESETIPCURL, OnBnClickedResetipcurl)
	ON_BN_CLICKED(IDC_AUTOUPIP2COUNTRY , OnSettingsChange)
	// IP2Country Auto-updating - End
	ON_BN_CLICKED(IDC_ANTILEECH_AUTOUP , OnSettingsChange)
	ON_WM_HELPINFO() //<<< [ionix] - ionixguide
END_MESSAGE_MAP()


BOOL CPPgIonixUpdate::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	((CEdit*)GetDlgItem(IDC_PPG_FAKEURL))->SetLimitText(250); // [TPT] - Fakecheck 
	((CEdit*)GetDlgItem(IDC_UPDATE_URL_IPFILTER))->SetLimitText(250); //MORPH END Ipfilter.dat update

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgIonixUpdate::LoadSettings(void)
{
	if(m_hWnd)
	{
		CString strBuffer;

		//MORPH START Ipfilter.dat update
		CheckDlgButton(IDC_AUTOUPIPFILTER, thePrefs.IsAutoUPdateIPFilterEnabled());
		//MORPH START Ipfilter.dat update

		//MORPH START Ipfilter.dat update
		strBuffer.Format(_T("v.%u"), thePrefs.GetIPfilterVersion());
		GetDlgItem(IDC_IPFILTER_VERSION)->SetWindowText(strBuffer);
		GetDlgItem(IDC_UPDATE_URL_IPFILTER)->SetWindowText(thePrefs.GetUpdateURLIPFilter());
		//MORPH START Ipfilter.dat update

		//MORPH START Ipfilter.dat update
		CheckDlgButton(IDC_UPDATEIPFURL, thePrefs.IsAutoUPdateIPFilterEnabled());
		//MORPH END Ipfilter.dat update

		// [TPT] - Fakecheck
		CheckDlgButton(IDC_PPG_FAKESTARTUP, thePrefs.IsUpdateFakeStartupEnabled());
		// [TPT] - Fakecheck

		// [TPT] - Fakecheck
		strBuffer.Format(_T("v.%u"), thePrefs.GetFakesDatVersion());
		GetDlgItem(IDC_PPG_FAKEVERSION)->SetWindowText(strBuffer);
		GetDlgItem(IDC_PPG_FAKEURL)->SetWindowText(thePrefs.GetUpdateURLFakeList());
		// [TPT] - Fakecheck

		// [TPT] - Fakecheck
		CheckDlgButton(IDC_PPG_FAKEUP, thePrefs.IsUpdateFakeStartupEnabled());
		// [TPT] - Fakecheck

		// IP2Country Auto-updating - Start
		GetDlgItem(IDC_UPDATE_URL_IP2COUNTRY)->SetWindowText(thePrefs.UpdateURLIP2Country);
		if(thePrefs.AutoUpdateIP2Country)
			CheckDlgButton(IDC_AUTOUPIP2COUNTRY,1);
		else
			CheckDlgButton(IDC_AUTOUPIP2COUNTRY,0);
		// IP2Country Auto-updating - End

		// IP2Country Auto-updating - Start
		GetDlgItem(IDC_UPDATE_VER_URL_IP2COUNTRY)->SetWindowText(thePrefs.UpdateVerURLIP2Country);
		// IP2Country Auto-updating - End

		// IP2Country Auto-updating - Start
		strBuffer.Format(_T("v.%u"), thePrefs.GetIP2CountryVersion());
		GetDlgItem(IDC_IP2COUNTRY_VERSION)->SetWindowText(strBuffer);
		// IP2Country Auto-updating - End

		CheckDlgButton(IDC_ANTILEECH_AUTOUP, thePrefs.IsAutoUPdateAntiLeechEnabled());
	} 
} 

BOOL CPPgIonixUpdate::OnApply()
{
	CString sBuffer;

	//MORPH START - Ipfilter.dat update
	thePrefs.AutoUpdateIPFilter = IsDlgButtonChecked(IDC_AUTOUPIPFILTER)!=0;
	//MORPH END   - Ipfilter.dat update

	//MORPH START - Ipfilter.dat update
	if(GetDlgItem(IDC_UPDATE_URL_IPFILTER)->GetWindowTextLength()) 
	{
		GetDlgItem(IDC_UPDATE_URL_IPFILTER)->GetWindowText(sBuffer);
		_tcscpy(thePrefs.UpdateURLIPFilter, sBuffer);
	}
	//MORPH END   - Ipfilter.dat update

	// [TPT] - Fakecheck
	thePrefs.UpdateFakeStartup = IsDlgButtonChecked(IDC_PPG_FAKESTARTUP)!=0;
	// [TPT] - Fakecheck
	
    // IP2Country Auto-updating - Start
	thePrefs.AutoUpdateIP2Country = IsDlgButtonChecked(IDC_AUTOUPIP2COUNTRY)!=0;
    // IP2Country Auto-updating - End

	thePrefs.AutoUpdateAntiLeech = IsDlgButtonChecked(IDC_ANTILEECH_AUTOUP)!=0;

	// [TPT] - Fakecheck
	if(GetDlgItem(IDC_PPG_FAKEURL)->GetWindowTextLength()) 
	{
		GetDlgItem(IDC_PPG_FAKEURL)->GetWindowText(sBuffer);
		_tcscpy(thePrefs.UpdateURLFakeList, sBuffer);
	}
	// [TPT] - Fakecheck end

    // IP2Country Auto-updating - Start
	if(GetDlgItem(IDC_UPDATE_URL_IP2COUNTRY)->GetWindowTextLength()) 
	{
		GetDlgItem(IDC_UPDATE_URL_IP2COUNTRY)->GetWindowText(sBuffer);
		_tcscpy(thePrefs.UpdateURLIP2Country, sBuffer);
	}
	// IP2Country Auto-updating - End

	// IP2Country Auto-updating - Start
	if(GetDlgItem(IDC_UPDATE_VER_URL_IP2COUNTRY)->GetWindowTextLength()) 
	{
		GetDlgItem(IDC_UPDATE_VER_URL_IP2COUNTRY)->GetWindowText(sBuffer);
		_tcscpy(thePrefs.UpdateVerURLIP2Country, sBuffer);
	}
	//thePrefs.AutoVerUpdateIP2Country = IsDlgButtonChecked(IDC_AUTOUPIP2COUNTRY)!=0;
	// IP2Country Auto-updating - End

	SetModified(FALSE);

	LoadSettings();
	return CPropertyPage::OnApply();
}

void CPPgIonixUpdate::Localize(void)
{
	if ( m_hWnd )
	{
		GetDlgItem(IDC_PPG_FAKEBOX)->SetWindowText(GetResString(IDS_PPG_FAKEBOX));
		GetDlgItem(IDC_PPG_FAKESTARTUP)->SetWindowText(GetResString(IDS_PPG_FAKESTARTUP));
		GetDlgItem(IDC_PPG_FAKEUP)->SetWindowText(GetResString(IDS_PPG_FAKEUP));
		GetDlgItem(IDC_UPDATEIPFURL)->SetWindowText(GetResString(IDS_UPDATEIPFURL));
		GetDlgItem(IDC_AUTOUPIPFILTER)->SetWindowText(GetResString(IDS_AUTOUPIPFILTER));
		GetDlgItem(IDC_SECURITY_RAHMEN)->SetWindowText(GetResString(IDS_SECURITY));
		GetDlgItem(IDC_RESETIPFURL)->SetWindowText(GetResString(IDS_PW_RESET));
		GetDlgItem(IDC_RESETFAKESURL)->SetWindowText(GetResString(IDS_PW_RESET));
		GetDlgItem(IDC_UPDATEIPCURL)->SetWindowText(GetResString(IDS_UPDATEIPCURL));
		GetDlgItem(IDC_AUTOUPIP2COUNTRY)->SetWindowText(GetResString(IDS_AUTOUPIP2COUNTRY));
		GetDlgItem(IDC_URL_FOR_UPDATING_IP2COUNTRY)->SetWindowText(GetResString(IDS_URL_FOR_UPDATING_IP2COUNTRY));
		GetDlgItem(IDC_IONIX_COUNTRY)->SetWindowText(GetResString(IDS_PREFSCOUNTRY));
		GetDlgItem(IDC_URL_FOR_UPDATING_IP2COUNTRY_VERFILE)->SetWindowText(GetResString(IDS_URL_FOR_UPDATING_IP2COUNTRY_VERFILE));
		GetDlgItem(IDC_RESETIPCURL)->SetWindowText(GetResString(IDS_PW_RESET));
		GetDlgItem(IDC_ANTILEECH_AUTOUP)->SetWindowText(GetResString(IDS_ANTILEECH_AUTOUP));
	}
}

CPPgIonixUpdate::~CPPgIonixUpdate(void)
{
}

//MORPH START added by [ionix] Ipfilter.dat update
void CPPgIonixUpdate::OnBnClickedUpdateipfurl()
{
	OnApply();
	theApp.ipfilter->UpdateIPFilterURL();
	CString strBuffer;
	strBuffer.Format(_T("v.%u"), thePrefs.GetIPfilterVersion());
	GetDlgItem(IDC_IPFILTER_VERSION)->SetWindowText(strBuffer);
}

void CPPgIonixUpdate::OnBnClickedResetipfurl()
{
	CString strBuffer = _T("http://emulepawcio.sourceforge.net/nieuwe_site/Ipfilter_fakes/ipfilter.zip");
	GetDlgItem(IDC_UPDATE_URL_IPFILTER)->SetWindowText(strBuffer);
	thePrefs.m_IPfilterVersion = 0;
	strBuffer.Format(_T("v.%u"), thePrefs.GetIPfilterVersion());
	GetDlgItem(IDC_IPFILTER_VERSION)->SetWindowText(strBuffer);
}
//MORPH START added by [ionix] Ipfilter.dat update

// [TPT] - Fakecheck
void CPPgIonixUpdate::OnBnClickedUpdatefakes()
{
	OnApply();
	theApp.FakeCheck->DownloadFakeList();
	CString strBuffer;
	strBuffer.Format(_T("v.%u"), thePrefs.GetFakesDatVersion());
	GetDlgItem(IDC_PPG_FAKEVERSION)->SetWindowText(strBuffer);
}
void CPPgIonixUpdate::OnBnClickedResetfakes()
{
	CString strBuffer = _T("http://emulepawcio.sourceforge.net/nieuwe_site/Ipfilter_fakes/fakes.zip");
	GetDlgItem(IDC_PPG_FAKEURL)->SetWindowText(strBuffer);
	thePrefs.m_FakesDatVersion = 0;
	strBuffer.Format(_T("v.%u"), thePrefs.GetFakesDatVersion());
	GetDlgItem(IDC_PPG_FAKEVERSION)->SetWindowText(strBuffer);
}
// [TPT] - Fakecheck

// IP2Country Auto-updating - Start
void CPPgIonixUpdate::OnBnClickedUpdateipcurl()
{
	OnApply();
	theApp.ip2country->UpdateIP2CountryURL();
	CString strBuffer;
	strBuffer.Format(_T("v.%u"), thePrefs.GetIP2CountryVersion());
	GetDlgItem(IDC_IP2COUNTRY_VERSION)->SetWindowText(strBuffer);
}

// IP2Country Auto-updating - End
void CPPgIonixUpdate::OnBnClickedResetipcurl()
{
	CString strBuffer = _T("http://ip-to-country.webhosting.info/downloads/ip-to-country.csv.zip");
	GetDlgItem(IDC_UPDATE_URL_IP2COUNTRY)->SetWindowText(strBuffer);
	strBuffer = _T("http://ip-to-country.webhosting.info/downloads/latest");
	GetDlgItem(IDC_UPDATE_VER_URL_IP2COUNTRY)->SetWindowText(strBuffer);
	thePrefs.SetIP2CountryVersion((uint32) 0);
	strBuffer.Format(_T("v.%u"), thePrefs.GetIP2CountryVersion());
	GetDlgItem(IDC_IP2COUNTRY_VERSION)->SetWindowText(strBuffer);
}

//>>> [ionix] - ionixguide
void CPPgIonixUpdate::OnHelp()
{
	theApp.ShowIonixHelp();
}

BOOL CPPgIonixUpdate::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (wParam == ID_HELP)
	{
		OnHelp();
		return TRUE;
	}
	return __super::OnCommand(wParam, lParam);
}

BOOL CPPgIonixUpdate::OnHelpInfo(HELPINFO* pHelpInfo)
{
	OnHelp();
	return TRUE;
}
//<<< [ionix] - ionixguide