#pragma once

class CPartFile;
class CUpDownClient;

class CSourceData
{
public:
	CSourceData(const uint32 dwID, const uint16 wPort, const TCHAR* exp, const uint8 srcexver); 
	CSourceData(const CUpDownClient* client, const TCHAR* exp);
	CSourceData(const CSourceData* pOld);
	bool Compare(const CSourceData* tocompare)	{return ((sourceID == tocompare->sourceID) && (sourcePort == tocompare->sourcePort));}

	uint32	sourceID;
	uint16	sourcePort;
	uint32	partsavailable;
	TCHAR	expiration[7];
	uint8	nSrcExchangeVer;
};

class CSourceSaver 
{
public:
	CSourceSaver();
	~CSourceSaver();
	bool Process(CPartFile* file);
	void DeleteFile(CPartFile* file, bool ErrIfFailed = true);

protected:
	typedef CTypedPtrList<CPtrList, CSourceData*> SourceList;

	void LoadSourcesFromFile(CPartFile* file, SourceList* sources, CString& slsfile);
	void SaveSources(CPartFile* file, SourceList* prevsources, const CString& slsfile, const int maxSourcesToSave);
	void AddSourcesToDownload(CPartFile* file, SourceList* sources);

	bool m_LoadSourcesOnStart;
	uint32	m_dwLastTimeLoaded;
	uint32  m_dwLastTimeSaved;

	CString CalcExpiration(int nDays);
	bool IsExpired(const CString& expirationdate);
};
