//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "SplashScreen.h"
#include "OtherFunctions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif


IMPLEMENT_DYNAMIC(CSplashScreen, CDialog)
/*
BEGIN_MESSAGE_MAP(CSplashScreen, CDialog)
	ON_WM_PAINT()
END_MESSAGE_MAP()
*/

CSplashScreen::CSplashScreen(CWnd* pParent /*=NULL*/)
	: CDialog(CSplashScreen::IDD, pParent)
{
	m_hThread = FALSE;
	m_bExitThread = FALSE;
	frames = 0;
	imgWidth = 0;
	imgHeight = 0;
	m_imgSplash = NULL;
	dcPointer = NULL;
}

CSplashScreen::~CSplashScreen()
{
	m_bExitThread = TRUE;
	if (m_hThread)
	{
		WaitForSingleObject(m_hThread,2000);
		CloseHandle(m_hThread);
		m_hThread = NULL;
		if(dcPointer)
		{
			for(int i=0;i<frames;i++)
				if(dcPointer[i].pOld)
					DeleteObject(dcPointer[i].pOld);
			delete[] dcPointer;
			dcPointer = NULL;
		}
	}
}

void CSplashScreen::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CSplashScreen::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitWindowStyles(this);

	m_imgSplash.LoadResource(FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(SPLASH), _T("GIF")), CXIMAGE_FORMAT_GIF);
	frames = m_imgSplash.GetNumFrames();
	//VERIFY( m_imgSplash.Attach(theApp.LoadImage(_T("SPLASH"), _T("JPG"))) ); // bobo
	if (m_imgSplash.IsValid())
	{
			imgWidth = m_imgSplash.GetWidth();
			imgHeight = m_imgSplash.GetHeight();
			WINDOWPLACEMENT wp;
			GetWindowPlacement(&wp);
			wp.rcNormalPosition.right = wp.rcNormalPosition.left + imgWidth;
			wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + imgHeight;
			SetWindowPlacement(&wp);
	}
	unsigned int nDummy;
	m_hThread = (HANDLE) _beginthreadex(NULL,0,_PaintGif,this,
		CREATE_SUSPENDED,&nDummy);
	if (!m_hThread)
		return FALSE;
	else 
	{
		ResumeThread(m_hThread);
		SetThreadPriority(m_hThread, THREAD_PRIORITY_ABOVE_NORMAL);
	}
	
	return true;
}

BOOL CSplashScreen::PreTranslateMessage(MSG* pMsg)
{
	BOOL bResult = CDialog::PreTranslateMessage(pMsg);

	if ((pMsg->message == WM_KEYDOWN	   ||
		 pMsg->message == WM_SYSKEYDOWN	   ||
		 pMsg->message == WM_LBUTTONDOWN   ||
		 pMsg->message == WM_RBUTTONDOWN   ||
		 pMsg->message == WM_MBUTTONDOWN   ||
		 pMsg->message == WM_NCLBUTTONDOWN ||
		 pMsg->message == WM_NCRBUTTONDOWN ||
		 pMsg->message == WM_NCMBUTTONDOWN))
	{
		DestroyWindow();
	}

	return bResult;
}


UINT WINAPI CSplashScreen::_PaintGif (LPVOID param) 
{ 
	ASSERT(param);
	DbgSetThreadName("SplashScreen");
	CSplashScreen *pKlasse = (CSplashScreen*)param;
	pKlasse->PaintGif();
	// this thread has finished its work so we close the handle
	CloseHandle(pKlasse->m_hThread); 
	pKlasse->m_hThread = 0;
	return 0;
}

void CSplashScreen::PaintGif()
{
	CPaintDC dc(this); // device context for painting

	int i = 0;
	bool bInMemory = false;
	//CDC dcMem;
	dcPointer = new dcStruct[frames];
	DWORD curTime;
	curTime = ::GetTickCount();
	//if (dcMem.CreateCompatibleDC(&dc))
	if (dcPointer)
	{
		while(!m_bExitThread)
		{
			if(!bInMemory)
			{
				m_imgSplash.SetFrame(i);
				m_imgSplash.LoadResource(FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(SPLASH), _T("GIF")), CXIMAGE_FORMAT_GIF);

				//HGDIOBJ pOld = dcMem.SelectObject(m_imgSplash.MakeBitmap()); //we need the pointer later to delete the gdi object
				if(!dcPointer[i].dc.CreateCompatibleDC(&dc))
					break;
				dcPointer[i].pOld = dcPointer[i].dc.SelectObject(m_imgSplash.MakeBitmap());
			}
			if(i!=0)
			{
				const DWORD diff = min(GetTickCount() - curTime, 100);
				Sleep(100-diff);
			}
			
			dc.BitBlt(0, 0, imgWidth, imgHeight, &dcPointer[i].dc, 0, 0, SRCCOPY);
			//dc.BitBlt(0, 0, imgWidth, imgHeight, &dcMem, 0, 0, SRCCOPY);
			//DeleteObject(pOld);

			curTime = ::GetTickCount();

			if(!bInMemory)
				m_imgSplash.Destroy();
			
			if(m_bExitThread) break;

			i++;
			if(i==frames)
			{
				i=0;
				bInMemory = true;
				m_imgSplash = NULL; // everything is now in the cache...
			}
			//i%=frames;
		}
		for(i=0;i<frames;i++)
			if(dcPointer[i].pOld)
				DeleteObject(dcPointer[i].pOld);		
	}
	SAFE_DELETE_ARRAY(dcPointer);
}